#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main()
{
  int pid; int pipefd[2]; char buf[512];

  pipe(pipefd);
  if ( (pid=vfork()) == 0) { /*child*/
      close(pipefd[0]); close(1); dup2(pipefd[1],1);
      execl("/bin/pwd","pwd",NULL);
      exit(-1);
  }
  if (pid < 0) {
      fprintf(stderr,"no vfork\n"); exit(-2);
  }
  close(pipefd[1]);
  if ((pid=read(pipefd[0],buf,512)) <=0) {
     fprintf(stderr,"error: %d\n",pid); exit(-3);
  }
  close(pipefd[0]);
  buf[pid]=0;
  printf("\n\npwd: %s\n\n",buf);
}
