#include   <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>
#include   <stdlib.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
   int      status, pid;
   extern int errno;
   if (argc < 2) {
      fprintf(stderr,"command-line argument required\n");
      exit(-1);
   }
   fprintf(stderr,"Kommando: %s\n",argv[1]);
   if ( (pid = fork()) == 0 ) {
      if (pid < 0 ) { 
	   fprintf(stderr,"fork error\n"); 
	   exit(0);
      }
      execlp(argv[1],argv[1],(char *)0);
      fprintf(stderr,"execle error: %d\n",errno);
      exit(1);
   }
   if (pid < 0 ) { 
      fprintf(stderr,"fork error\n"); 
      exit(0);
   }
   waitpid(pid,&status,0);
   fprintf(stderr,"status: %d\n",status);
   exit(0);
}
