/* server test  */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/wait.h>
#include <string.h>
#include <errno.h>

/*    Liste der Fehlernummern  
    LINUX 
       /usr/include/asm-generic/errno-base.h  
       /usr/include/asm-generic/errno.h  
   Solaris 
       /usr/include/sys/errno.h
*/
 

pid_t	spid,cpid;

int main()
{
  char buffer[512];
  char out[512];
  int lgt,status,res;

  spid=getpid();
  sprintf(out,"Server (%d) startet\n",spid);
  write(2,out,strlen(out));

  for (;;) {
     write(1,": ",2);
     if (( lgt=read(0,buffer,512)) <=0) {
        sprintf(out,"Server ended\n");
        write(2,out,strlen(out));
        exit(-1);
     }
     if ( (cpid = fork()) < 0) {
          sprintf(out,"server can't fork\n");
          write(2,out,strlen(out));
          exit(-2);
     }
     if (cpid == 0) {	
        /* child 1 */
        cpid=getpid();
        sprintf(out,"Client 1 (%d) start.\n",cpid);
        write(2,out,strlen(out));
        sleep(5);
        res=buffer[0]-'a';
        sprintf(out,"Client 1 (%d) end with %d.\n",cpid,res);
        write(2,out,strlen(out));
        exit(res);
     }
     /* Server nach fork */
     sprintf(out,"Server (%d) start client %d \n",spid,cpid);
     write(2,out,strlen(out));
     while ((res=waitpid(-1,&status,WNOHANG)) >0) { 
        sprintf(out,"Server wait successfull. RES: %d, Status: %d, errno: %d, Text: %s\n",
                res,WEXITSTATUS(status),errno,strerror(errno));
        write(2,out,strlen(out));
     }
     sprintf(out,"Server wait failed. RES: %d, Status: %d,errno: %d, Text: %s\n",
               res,WEXITSTATUS(status),errno,strerror(errno));
     write(2,out,strlen(out));
  }
  exit(0);
}
